Package org.optaplanner.core.api.score.buildin.simplebigdecimal

## Interface SimpleBigDecimalScoreHolder

- All Superinterfaces:
    `ScoreHolder<SimpleBigDecimalScore>`
  All Known Implementing Classes:
    `SimpleBigDecimalScoreHolderImpl`

      public interface SimpleBigDecimalScoreHolder
      extends ScoreHolder<SimpleBigDecimalScore>

  See Also:
    `SimpleBigDecimalScore`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weight)` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` |
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.

    - ### Methods inherited from interface org.optaplanner.core.api.score.holder.ScoreHolder

      `penalize, reward`

- - ### Method Detail

    - #### penalize

          void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                        BigDecimal weightMultiplier)

      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                      BigDecimal weightMultiplier)

      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### impactScore

          void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                           BigDecimal weightMultiplier)

    - #### addConstraintMatch

          void addConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weight` - never null, higher is better, negative for a penalty, positive for a reward